#ifndef __VendingMachine_h__
#define __VendingMachine_h__

#include "../fsm.h"
#include <iostream>

enum State
{
    Start,
    Five,
    Ten,
    Fifteen,
    Twenty,
    Change
};

enum Event
{
    Nickel,
    Dime,
    Quarter,
    Restart,
    Exit
};

class Impl
{
public:
    void dispense();
    void returnNickel();
    void returnDime();
    void returnDimeAndNickel();
    void returnDimeAndDime();
};

typedef TYPELIST_16(
        FSM_TRANSITION_NO_ACTION(Start,Nickel, Five), 
        FSM_TRANSITION_NO_ACTION(Start,Dime,   Ten),
        FSM_TRANSITION          (Start,Quarter,Start,Impl,dispense),

        FSM_TRANSITION_NO_ACTION(Five,Nickel, Ten), 
        FSM_TRANSITION_NO_ACTION(Five,Dime,   Fifteen),
        FSM_TRANSITION          (Five,Quarter,Change, Impl,returnNickel),

        FSM_TRANSITION_NO_ACTION(Ten,Nickel, Fifteen), 
        FSM_TRANSITION_NO_ACTION(Ten,Dime,   Twenty), 
        FSM_TRANSITION          (Ten,Quarter,Change, Impl,returnDime),

        FSM_TRANSITION_NO_ACTION(Fifteen,Nickel, Twenty), 
        FSM_TRANSITION          (Fifteen,Dime,   Start, Impl,dispense),
        FSM_TRANSITION          (Fifteen,Quarter,Change,Impl,returnDimeAndNickel),

        FSM_TRANSITION          (Twenty,Nickel, Start, Impl,dispense), 
        FSM_TRANSITION          (Twenty,Dime,   Change,Impl,returnNickel), 
        FSM_TRANSITION          (Twenty,Quarter,Change,Impl,returnDimeAndDime),

        FSM_TRANSITION          (Change,Restart,Start,Impl,dispense)
) 
TransitionTable;

class VendingMachine : public fsm::Builder<TransitionTable,State,Event>
{
};

#endif //!__VendingMachine_h__

