#include <iostream>
#include <crtdbg.h>
#include "display.h"

using namespace std;

Event prompt()
{
    cout << endl;
    cout << "              You can drop: "<< endl;
    cout << "                Nickel(n)"   << endl;
    cout << "                Dime(d)"     << endl;
    cout << "                Quarter(q)"  << endl;
    cout << "                or exit(e)"  << endl;
    cout << "              type your choice and <enter>."  << endl;
    cout << "              >> ";

    char ch;
    cin >> ch;
    switch(ch)
    {
        case 'n':
        case 'N':   return Nickel;
        case 'd':
        case 'D':   return Dime;
        case 'q':
        case 'Q':   return Quarter;
        case 'e':
        case 'E':   return Exit;
        default:
                    cout << "              Unknown coin!!!! Try again."  << endl;
                    return prompt();
    }
}

template <int CENTS> void displayCentsLeft();
template <> void displayCentsLeft<25>()
{
    cout << "           $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$" << endl;
    cout << "           $$                           $$" << endl;
    cout << "           $$     ####      ##########  $$" << endl;
    cout << "           $$   ##    ##    ##      ##  $$" << endl;
    cout << "           $$  ##      ##     ##        $$" << endl;
    cout << "           $$          ##        ##     $$" << endl;
    cout << "           $$         ##           ##   $$" << endl;
    cout << "           $$       ##              ##  $$" << endl;
    cout << "           $$    ##         ##      ##  $$" << endl;
    cout << "           $$  ##      ##    ##    ##   $$" << endl;
    cout << "           $$  ##########      ####     $$" << endl;
    cout << "           $$                           $$" << endl;
    cout << "           $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$" << endl;
}

template <> void displayCentsLeft<20>()
{
    cout << "           $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$" << endl;
    cout << "           $$                           $$" << endl;
    cout << "           $$     ####         ####     $$" << endl;
    cout << "           $$   ##    ##     ##    ##   $$" << endl;
    cout << "           $$  ##      ##   ##      ##  $$" << endl;
    cout << "           $$          ##   ##      ##  $$" << endl;
    cout << "           $$         ##    ##      ##  $$" << endl;
    cout << "           $$       ##      ##      ##  $$" << endl;
    cout << "           $$    ##         ##      ##  $$" << endl;
    cout << "           $$  ##      ##    ##    ##   $$" << endl;
    cout << "           $$  ##########      ####     $$" << endl;
    cout << "           $$                           $$" << endl;
    cout << "           $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$" << endl;
}

template <> void displayCentsLeft<15>()
{
    cout << "           $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$" << endl;
    cout << "           $$                           $$" << endl;
    cout << "           $$      ##       ##########  $$" << endl;
    cout << "           $$     ###       ##      ##  $$" << endl;
    cout << "           $$    ####         ##        $$" << endl;
    cout << "           $$      ##            ##     $$" << endl;
    cout << "           $$      ##              ##   $$" << endl;
    cout << "           $$      ##               ##  $$" << endl;
    cout << "           $$      ##       ##      ##  $$" << endl;
    cout << "           $$      ##        ##    ##   $$" << endl;
    cout << "           $$  ##########      ####     $$" << endl;
    cout << "           $$                           $$" << endl;
    cout << "           $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$" << endl;
}


template <> void displayCentsLeft<10>()
{
    cout << "           $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$" << endl;
    cout << "           $$                           $$" << endl;
    cout << "           $$      ##          ####     $$" << endl;
    cout << "           $$     ###        ##    ##   $$" << endl;
    cout << "           $$    ####       ##      ##  $$" << endl;
    cout << "           $$      ##       ##      ##  $$" << endl;
    cout << "           $$      ##       ##      ##  $$" << endl;
    cout << "           $$      ##       ##      ##  $$" << endl;
    cout << "           $$      ##       ##      ##  $$" << endl;
    cout << "           $$      ##        ##    ##   $$" << endl;
    cout << "           $$  ##########      ####     $$" << endl;
    cout << "           $$                           $$" << endl;
    cout << "           $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$" << endl;
}

template <> void displayCentsLeft<5>()
{
    cout << "           $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$" << endl;
    cout << "           $$                           $$" << endl;
    cout << "           $$        ##########         $$" << endl;
    cout << "           $$        ##      ##         $$" << endl;
    cout << "           $$          ##               $$" << endl;
    cout << "           $$             ##            $$" << endl;
    cout << "           $$               ##          $$" << endl;
    cout << "           $$                ##         $$" << endl;
    cout << "           $$        ##      ##         $$" << endl;
    cout << "           $$         ##    ##          $$" << endl;
    cout << "           $$           ####            $$" << endl;
    cout << "           $$                           $$" << endl;
    cout << "           $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$" << endl;
}


void display(const VendingMachine& machine)
{
    switch(machine.state())
    {
        case Start  :   displayCentsLeft<25>();
                        break;
        case Five   :   displayCentsLeft<20>();
                        break;
        case Ten    :   displayCentsLeft<15>();
                        break;
        case Fifteen:   displayCentsLeft<10>();
                        break;
        case Twenty :   displayCentsLeft<5>();
                        break;
        default     :   _ASSERT(false);
                        break;
    }
}


