#include <iostream>
#include "thirdPartyComponents.h"

using namespace std;


namespace log
{
void trace(const char* msg)
{
    if(msg)
        cout << msg << endl;    
}    
}

namespace gui
{

void initLibrary()
{
    cout << "gui library was initialized" << endl;
}
void uninitLibrary()
{
    cout << "gui library was uninitialized" << endl;
}

void Dialog::scrollAway()
{
    const short lines = 32;
    for(int i = 0; i < lines; ++i)
        cout << endl;
}

RET_CODE Dialog::doModal()
{
    scrollAway();
    return doContent();
}

RET_CODE GreetingDlg::doContent()
{
    cout << "       -------------------------------------------------" << endl;
    cout << "       |-----------------------------------------------|" << endl;
    cout << "       |                                               |" << endl;
    cout << "       | Welcome to XYZ System                         |" << endl;
    cout << "       |----------------------                         |" << endl;
    cout << "       |                                               |" << endl;
    cout << "       |                                               |" << endl;
    cout << "       |                                               |" << endl;
    cout << "       | to enter the system                           |" << endl;
    cout << "       | press any key and <enter>                     |" << endl;
    cout << "       |-----------------------------------------------|" << endl;
    cout << "       -------------------------------------------------" << endl;
    cout << "       >> ";

    char ch;
    cin >> ch;
    return RC_OK;
}

RET_CODE LoginScreenDlg::doContent()
{
    _pwd = "";

    cout << "       -------------------------------------------------" << endl;
    cout << "       |-----------------------------------------------|" << endl;
    cout << "       |                                               |" << endl;
    cout << "       | XYZ System. Login dialog box                  |" << endl;
    cout << "       |-----------------------------                  |" << endl;
    cout << "       |                                               |" << endl;
    cout << "       |                                               |" << endl;
    cout << "       | You can                                       |" << endl;
    cout << "       | 1. type your password and <enter>             |" << endl;
    cout << "       | 2. type 'cancel' and <enter>                  |" << endl;
    cout << "       | --------                                      |" << endl;
    cout << "       | Hint: correct password is '123'               |" << endl;
    cout << "       |-----------------------------------------------|" << endl;
    cout << "       -------------------------------------------------" << endl;
    cout << "       >> ";

    cin >> _pwd;
    if(_pwd=="cancel")
        return RC_CANCEL;
    return RC_OK;
}

RET_CODE BadPasswordDlg::doContent()
{
    cout << "       -------------------------------------------------" << endl;
    cout << "       |-----------------------------------------------|" << endl;
    cout << "       |                                               |" << endl;
    cout << "       | XYZ System. Bad password dialog box           |" << endl;
    cout << "       |------------------------------------           |" << endl;
    cout << "       |                                               |" << endl;
    cout << "       |                                               |" << endl;
    cout << "       | You can                                       |" << endl;
    cout << "       | 1. press any key and <enter> to return Login  |" << endl;
    cout << "       | 2. type 'cancel' and <enter>                  |" << endl;
    cout << "       |-----------------------------------------------|" << endl;
    cout << "       -------------------------------------------------" << endl;
    cout << "       >> ";

    string val;
    cin >> val;
    if(val=="cancel")
        return RC_CANCEL;
    return RC_OK;
}

RET_CODE LockScreenDlg::doContent()
{
    _pwd = "";

    cout << "       -------------------------------------------------" << endl;
    cout << "       |-----------------------------------------------|" << endl;
    cout << "       |                                               |" << endl;
    cout << "       | XYZ System. Lock screen                       |" << endl;
    cout << "       |------------------------                       |" << endl;
    cout << "       |                                               |" << endl;
    cout << "       |                                               |" << endl;
    cout << "       | You can only                                  |" << endl;
    cout << "       | type admin password and <enter>               |" << endl;
    cout << "       |                                               |" << endl;
    cout << "       | --------                                      |" << endl;
    cout << "       | Hint: correct adminpassword is '456'          |" << endl;
    cout << "       |-----------------------------------------------|" << endl;
    cout << "       -------------------------------------------------" << endl;
    cout << "       >> ";

    cin >> _pwd;
    if(_pwd=="cancel")
        return RC_CANCEL;
    return RC_OK;
}

} // end of gui namespace

namespace kernel
{

Guard::Guard()
{
}

Guard* Guard::getInstance(const char* /*someInputArgument*/) 
{
    cout << "kernel::Guard has been created" << endl;
    return new Guard;
}

void Guard::releaseInstance(Guard* guard) 
{
    delete guard;
    cout << "kernel::Guard has been destroyed" << endl;
}


bool Guard::checkUserPwd(const char* pwd) const
{
    const string USER_PWD("123");
    if(USER_PWD==pwd)
        return true;    
    return false;    
}


bool Guard::checkAdminPwd(const char* pwd) const
{
    const string ADMIN_PWD("456");
    if(ADMIN_PWD==pwd)
        return true;
    return false;
}

} // end of kernel namespace
